
function Skinner:Violation()

	if Violation.db.char.showWindows then 
		self:skinViolation() 
	else
		self:SecureHook(Violation, "OpenWindows", function()
--			self:Debug("V_OpenWindows")
			self:skinViolation()
			end)
	end

	self:SecureHook(Violation, "SetupWindows", function()
--		self:Debug("SetupWindows")
		self:skinViolation()
		end)

	self:SecureHook(Violation, "UpdateWindows", function(sameamount)
--		self:Debug("UpdateWindows")
		self:skinViolation()
		end)

end

function Skinner:skinViolation()

	for i = 1, Violation.db.char.windows.count do
		local Vw = Violation.windows[i]
--		self:Debug("V-window: [%s]", Vw)
		if Vw then
			local frame = Vw.frame
			if not frame.skinned then
				frame.header:SetWidth(frame:GetWidth() - 48)
				self:moveObject(frame.header, nil, nil, "+", 9, frame)
				self:moveObject(frame.closebutton, nil, nil, "+", 9, frame)
				self:moveObject(frame.prevbutton, nil, nil, "+", 9, frame)
				self:moveObject(frame.nextbutton, nil, nil, "+", 9, frame)
				self:applySkin(frame)
				frame.skinned = true
				-- hook these to stop the Backdrop colours from being changed 
				self:Hook(frame, "SetBackdropColor", function(r, g, b, a) end, true)
				self:Hook(frame, "SetBackdropBorderColor", function(r, g, b, a) end, true)
				-- hook this to manage the statusbars
				self:SecureHook(Vw, "SetBar", function(self, count, rank, name, value, percent, dataInfo)
					local btn = self.currentBars[count]
--					Skinner:Debug("V-statusbar: [%s, %s]", btn, btn.statusbar)
					if btn then
--						Skinner:Debug("V: [%s, %s]", btn, btn:GetWidth())
						btn:ClearAllPoints()						
						if count == 1 then
							btn:SetPoint( "TOP", self.frame, "TOP", 0, -21 )
						else
							btn:SetPoint( "TOP", self.currentBars[count - 1], "BOTTOM", 0, -1 )
						end
						btn:SetPoint( "LEFT", self.frame, "LEFT", 4, 0)
						btn:SetPoint( "RIGHT", self.frame, "RIGHT", -4, 0)
					end
					end)
				
			end
		end
	end
	
end
