local _G = getfenv(0)

function Skinner:beql()

	self:SecureHook(beql, "Hooks_QuestLog_UpdateQuestDetails", function(doNotScroll)
		BEQL_QuestLogQuestTitle:SetTextColor(HTr, HTg, HTb)
		BEQL_QuestLogObjectivesText:SetTextColor(BTr, BTg, BTb)
		BEQL_QuestLogTimerText:SetTextColor(BTr, BTg, BTb)
		for i = 1, 10 do
    		_G["BEQL_QuestLogObjective"..i]:SetTextColor(BTr, BTg, BTb)
    	end
    	BEQL_QuestLogRequiredMoneyText:SetTextColor(BTr, BTg, BTb)
		BEQL_QuestLogDescriptionTitle:SetTextColor(HTr, HTg, HTb)
		BEQL_QuestLogQuestDescription:SetTextColor(BTr, BTg, BTb)
    	BEQL_QuestLogRewardTitleText:SetTextColor(HTr, HTg, HTb)
    	BEQL_QuestLogItemChooseText:SetTextColor(BTr, BTg, BTb)
    	BEQL_QuestLogItemReceiveText:SetTextColor(BTr, BTg, BTb)
		end)
		
	self:SecureHook(beql, "Maximize", function()
		self:moveObject(BEQL_QuestLogVersionText, "-", 20, nil, nil)
		end)
	
	self:SecureHook(beql, "Minimize", function()
		self:moveObject(BEQL_QuestLogVersionText, "-", 20, nil, nil)
		self:moveObject(BEQL_QuestFrameOptionsButton, "-", 10, nil, nil)
		end)
	
	self:keepFontStrings(BEQL_QuestLogFrame)
	BEQL_QuestLogFrame:SetWidth(BEQL_QuestLogFrame:GetWidth() * FxMult)
	self:moveObject(BEQL_QuestLogFrameCloseButton, "+", 28, "+", 8)
	self:keepRegions(BEQL_QuestLogCollapseAllButton, {4, 6}) -- N.B. region 4 is button, 6 is text
	self:keepFontStrings(BEQL_QuestLogFrame_Details)
	self:moveObject(BEQL_QuestLogFrameAbandonButton, "-", 10, nil, nil)
	self:moveObject(BEQL_QuestLogVersionText, "-", 20, nil, nil)
	self:moveObject(BEQL_QuestFrameOptionsButton, "-", 10, nil, nil)
	self:applySkin(BEQL_QuestLogFrame)
-->>-- Quest Log Description Frame
	self:keepFontStrings(BEQL_QuestLogFrame_Description)
	BEQL_QuestLogFrame_Description:SetWidth(BEQL_QuestLogFrame:GetWidth())
	self:moveObject(BEQL_QuestLogFrame_Description, "-", 8, nil, nil)
	self:keepFontStrings(BEQL_QuestLogDetailScrollFrame)
	self:skinScrollBar(BEQL_QuestLogDetailScrollFrame)
	self:moveObject(BEQL_QuestLogFrameCloseButton2, "+", 20, "+", 8)
	self:moveObject(BEQL_QuestLogQuestTitle, nil, nil, "+", 12)
	self:applySkin(BEQL_QuestLogFrame_Description)
-->>-- Quest Watch Frame
	self:applySkin(QuestWatchFrameBackdrop)
	self:Hook(QuestWatchFrameBackdrop, "SetBackdropColor", function(r, g, b, a) end, true)
	self:Hook(QuestWatchFrameBackdrop, "SetBackdropBorderColor", function(r, g, b, a) end, true)

end
